//
// video.h
//
// Uses the GGI (General Graphic Interface) System
//

ggi_visual_t vis=NULL;
const ggi_directbuffer *db=NULL;
ggi_color pal[256];

#define MWIDTH 1024
#define MHEIGHT 768
long WIDTH=640;
long HEIGHT=480;

//#define setpix(x,y,c)       Screen[(y)*WIDTH+(x)]=(c)
#define setpix(x,y,c)       VScreen[((y)*WIDTH)+(x)]=(c)
//#define getpix(x,y)         Screen[(y)*WIDTH+(x)]
#define getpix(x,y)         VScreen[((y)*WIDTH)+(x)]
#define ssetpix(x, y, c)    if ( ((y)<Munten)&&((y)>Moben)&&((x)>Mlinks)&&((x)<Mrechts) ) VScreen[(y)*WIDTH+(x)]=(c)


U1 *Screen=NULL; // was 0xA0000 under DOS
U1 *VScreen=NULL;

int init640x480 ( void )
{
  Screen=new U1[WIDTH*HEIGHT];
  VScreen=new U1[WIDTH*HEIGHT];
  if(vis!=NULL) return 0;
  if(ggiInit()) return 0;
  printf("GGI_DISPLAY=%s\n",getenv("GGI_DISPLAY"));
  if((vis=ggiOpen(NULL))==NULL) return 0;
  printf("GGI-Visual ok.\n");
  if(ggiSetGraphMode(vis,WIDTH,HEIGHT,WIDTH,HEIGHT,GT_8BIT)) 
  {
    printf("Der 8-Bit Farbmodus funktioniert nicht.\n");
    printf("Das Visual wird wieder geschlossen ...\n");
    if(vis!=NULL) if(ggiClose(vis)) return 0;
    printf("Es wird nun versucht, mit dem palemu Modus, den 8-Bit Farbmodus zu emulieren...\n");
    if((vis=ggiOpen("display-palemu","",NULL))==NULL) return 0;
    printf("Palemu-Visual ok.\n");
    if(ggiSetGraphMode(vis,WIDTH,HEIGHT,WIDTH,HEIGHT,GT_8BIT)) return 0;
    printf("Palemu funktioniert.\n");
  }
  printf("Der Grafikmodus scheint in Ordnung zu sein.\n");
  if((db=ggiDBGetBuffer(vis,0))==NULL)
  {
    printf("DirectBuffer ist nicht verfgbar, normale Pufferung wird verwendet.\n");
  }
  else
  {
    printf("DirectBuffer ist verfgbar und wird verwendet.\n");
    //if(db->type!=GGI_DB_SIMPLE_PLB|GGI_DB_NORMAL) return 0;
    Screen=(U1*)db->write;
  }
  return 1;
}
 

void textmodus( void )
{
  //GGI seems to be buggy. Try to reactivate the code again.
  #if 0
  if(vis!=NULL)
  {
    if(ggiClose(vis)) return 0;
    if(ggiExit()) return 0;
  }
  #endif
}

void Put()
{
  if(vis==NULL) return;
  if(db==NULL) ggiPutBox(vis,0,0,WIDTH,HEIGHT,Screen);
  ggiFlush(vis);
};


void Cpy2Screen ( void )
{
  if(db==NULL) ggiPutBox(vis,0,0,WIDTH,HEIGHT,VScreen);
  else memcpy(Screen, VScreen, WIDTH*HEIGHT);
}

void Set_Palette(U2 start,U2 end,U1 *palette,char Shift)
{
  if(vis==NULL) return;
  ggi_color myGGIpal[256];
  U2 i;
  for (i=0;i<=(end-start);i++) 
  {
    myGGIpal[i].r=palette[i*3+0]<<(10-Shift);
    myGGIpal[i].g=palette[i*3+1]<<(10-Shift);
    myGGIpal[i].b=palette[i*3+2]<<(10-Shift);
  }
  ggiSetPalette(vis,start,end-start+1,myGGIpal);
}

void Set_Palette2(U2 start,U2 end,ggi_color *palette,U1 blend)
{
  ggi_color myGGIpal[256];
  U2 i;
  if(vis==NULL) return;

  for (i=0;i<=(end-start);i++) 
  {
    myGGIpal[i].r=palette[i].r*blend>>6;
    myGGIpal[i].g=palette[i].g*blend>>6;
    myGGIpal[i].b=palette[i].b*blend>>6;
  }
  ggiSetPalette(vis,start,end-start+1,myGGIpal);

};

/****************************************************************************/
/* Blendet den Bildschirm aus.                                              */
/* ------------------------------------------------------------------------ */
/* keine Parameter.                                                         */
/****************************************************************************/
void FadeOut( void)
{
/*
  int blend_count;

  for (blend_count=64;blend_count>=0;blend_count--)
  {
     wait_vretrace();
     Set_Palette2(0,255,PALETTE,blend_count);
  }
  ggiSetPalette(vis,0,256,PALETTE);
*/
}


void FlashOut ( void )
{
/*
  int i;
  int fertig=0;

  while ( fertig == 0 )
  {
    fertig = 1;

    for(i=0; i<255; i++)
    {
      if ( Palette[i].rot   != 255 ) { Palette[i].rot++;   fertig = 0; }
      if ( Palette[i].gruen != 255 ) { Palette[i].gruen++; fertig = 0; }
      if ( Palette[i].blau  != 255 ) { Palette[i].blau++;  fertig = 0; }
    }
    SetPalette(&Palette);
  }
*/
}

void FlashIn ( void )
{
/*
  short i;
  byte fertig=0;
  PAL pal[256];

  memset(pal, 255, 768);
  GetPalette(&Palette);

  while ( fertig == 0 )
  {
    fertig = 1;

    for(i=0; i<256; i++)
    {
      if ( pal[i].rot   > Palette[i].rot )   { pal[i].rot--;   fertig=0; }
      if ( pal[i].gruen > Palette[i].gruen ) { pal[i].gruen--; fertig=0; }
      if ( pal[i].blau  > Palette[i].blau )  { pal[i].blau--;  fertig=0; }
    }
    SetPalette(&pal);
  }
*/
}

void GrayIn ( void )
{
/*
  short i;
  byte fertig=0;
  PAL pal[256];

  GetPalette(&Palette);
  GetPalette(&pal);

  while ( fertig == 0 )
  {
    fertig = 1;

    for(i=0; i<256; i++)
    {
      if ( pal[i].rot   > (Palette[i].rot*80)/100 )   { pal[i].rot--;   fertig=0; }
      if ( pal[i].gruen > (Palette[i].gruen*80)/100 ) { pal[i].gruen--; fertig=0; }
      if ( pal[i].blau  > (Palette[i].blau*80)/100 )  { pal[i].blau--;  fertig=0; }
    }
    SetPalette(&pal);
  }
*/
}

void BildAus ( void )
{
/*
  short i;
  FlashOut();
  for(i=0; i<198; i+=4)
  {
    memset(&VScreen[(WIDTH*i)], 255, WIDTH*4); memset(&VScreen[(ResX*(398-i))], 255, WIDTH*4);
    Cpy2Screen();
  }
  for(i=0; i<318; i+=4)
  {
    memset(&VScreen[(WIDTH*(HEIGHT/2-2))+i], 255, 4); memset(&VScreen[(WIDTH*(HEIGHT/2-1))+i], 255, 4);
    memset(&VScreen[(WIDTH*HEIGHT/2)+i], 255, 4); memset(&VScreen[(WIDTH*(HEIGHT/2+1))+i], 255, 4);
    memset(&VScreen[(WIDTH*(HEIGHT/2-2))+(WIDTH-i)], 255, 4); memset(&VScreen[(WIDTH*(HEIGHT/2-1))+(WIDTH-i)], 255, 4);
    memset(&VScreen[(WIDTH*HEIGHT/2)+(WIDTH-i)], 255, 4); memset(&VScreen[(WIDTH*(HEIGHT/2+1))+(WIDTH-i)], 255, 4);
    Cpy2Screen();
  }
  FadeOut();
*/
}

